#include <Adafruit_CircuitPlayground.h>
#include <math.h>

const uint32_t PROGMEM COLORS[] = { 0xFF0000, 0x00FF00, 0x0000FF, 0xFFFF00, 0xFF00FF, 0x00FFFF, 0x007BA7, 0x007BA7, 0x007BA7, 0x007BA7 };
//const uint32_t PROGMEM COLORS[] = { 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111, 0xEE1111 };

unsigned long last;
uint8_t start = 0;

void setup ()
{
  CircuitPlayground.begin();
  CircuitPlayground.setBrightness(1);
  CircuitPlayground.clearPixels();

  last = 0;
}

void loop ()
{
  unsigned long now = millis();

  CircuitPlayground.setBrightness(ceil(CircuitPlayground.lightSensor() / (float)1023 * 255));

  if (now - last < 1000)
  {
    return;
  }

  uint8_t index = start;
  for (uint8_t i = 0; i < 10; i++)
  {
    CircuitPlayground.strip.setPixelColor(i, pgm_read_dword(COLORS + index));
    index = (index + 1) % 10;
  }
  start = (start +  1) % 10;

  last = now;
  CircuitPlayground.strip.show();
}

