#define PACMAN_TIME 18000

#define PACMAN 255, 255, 0
#define POWER 255, 52, 52
#define PILL 128, 128, 128
#define INKY 0, 255, 255
#define PINKY 255, 0, 255
#define BLINKY 255, 0, 0
#define CLYDE 255, 50, 0
#define SCARED 0, 0, 255

int8_t p_pacman = 0;
int8_t p_ghost1 = -4;
int8_t p_ghost2 = -5;
int8_t p_direction = 1;

int8_t p_eaten[] = {1, 0, 0, 0, 0, 0, 0, 0, 0, 0};

void pacman_reset ()
{
  p_pacman = 0;
  p_ghost1 = -4;
  p_ghost2 = -5;
  p_direction = 1;

  for (uint8_t i = 1; i < 10; i++)
  {
    p_eaten[i] = 0;
  }
}

bool pacman (unsigned long progress)
{
  if (progress % 500 <= 1 && (p_direction > 0 || p_pacman >= 0))
  {
    for (int8_t pixel = 0; pixel < 10; pixel++)
    {
      if (pixel == p_pacman)
      {
        CircuitPlayground.strip.setPixelColor(pixel, PACMAN);
      }
      else if ((pixel == p_ghost1 || pixel == p_ghost2) && p_direction < 0)
      {
        CircuitPlayground.strip.setPixelColor(pixel, SCARED);
      }
      else if (pixel == p_ghost1)
      {
        CircuitPlayground.strip.setPixelColor(pixel, BLINKY);
      }
      else if (pixel == p_ghost2)
      {
        CircuitPlayground.strip.setPixelColor(pixel, CLYDE);
      }
      else if (p_eaten[pixel] == 1)
      {
        CircuitPlayground.strip.setPixelColor(pixel, OFF);
      }
      else if (pixel == 9)
      {
        CircuitPlayground.strip.setPixelColor(pixel, POWER);
      }
      else
      {
        CircuitPlayground.strip.setPixelColor(pixel, PILL);
      }
    }

    p_pacman += p_direction;
    p_ghost1 += p_direction;
    p_ghost2 += p_direction;

    if (p_pacman == 9 || p_pacman == -1)
    {
      p_direction = ~p_direction + 1;
    }
    p_eaten[p_pacman] = 1;

    return p_pacman == -1;
  }
  return false;
}

